#if defined(__linux__)
#if defined(__hppa__)

	.section .text

	.globl	$$dyncall
	.type	$$dyncall, @function
$$dyncall:
	/*
	 * For function call as pointer.
	 * (It is possible to avoid to use by option -mfast-indirect-calls)
	 */
#if 1
	/* jump to r22 */
	bv	%r0(%r22) 
	nop
#else
	/* code by option -mfast-indirect-calls */
	stw	%rp, -14(%sp)
	ldo	40(%sp), %sp

	be,l	0(%sr4, %r22), %sr0, %r31
	copy	%r31, %rp

	ldw	-54(%sp), %rp
	bv	%r0(%rp)
	ldo	-40(%sp), %sp
#endif

#endif
#endif
